<?php
/***********************************************************************************
 * Stalker ---- Social Networking 'Stalker' module
 *
 * @version		V1.1.3
 * @author		Nick Texidor <nick@texidor.com>
 * @link		http://www.nicktexidor.com
 * @copyright 	Copyright (C) 2008-2010 Nick Texidor. All rights reserved.
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL 
 * 
 * Stalker is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Stalker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Stalker.  If not, see <http://www.gnu.org/licenses/>.
 *
 * History
 *
 * 1.1.3		08/03/10
 *				Updated template code to display new LinkTitle and ImageAlt fields
 *				Added a clear DIV after the stalker output
 *				Updated Image & Stylesheet Joomla calls
 *
 * 1.1.2		04/03/10
 *				Fixed the link to the CSS file for ALL styles to stop border showing up
 *				Reworked the icons and links to work as CSS list items
 *				Added new Position field to Module Preferences
 *				Tidied up the Module Preferences
 *				Unpublished icons should no longer display.  - Thanks Gruz 
 *
 * 1.1.1		08/11/09
 *				Wrapped the output html in a div & updated style sheet to better 
 *				handle styles & disable icon borders
 *
 * 1.1.0		Added Stalker Group option (requires com_stalker) - This will allow 
 *					multiple modules to be added choosing the icons from that group
 *
 * 1.0.2		Border & Name elements removed for strict validation
 *				Username/Id added to ALT & TITLE parameters
 *
 * 1.0.1		New module parameter added to change the module display (Image, List, Text)
 *
 * 1.0.0		Major changes relating to release of Stalker Component. (Using
 *					component provides more features such as ordering of icons,
 *					unlimited links, setting link targets & better image handling):
 * 
 *					New preference option to use database for Stalker Links
 *
 * 0.0.93		Fixed W3 Validation errors
 *
 * 0.0.92		Fixed the link to Ning
 *				Added Width & Height tags for images 
 *				Added more sizing options
 *				Changed the way images are handled. ONLY 64px x 64px icons are now provided. 
 *					The size is still set in module admin, but the image width & height
 *					tags govern the displayed size.  This doesn't add much to the overhead
 *					but the icons reduced by the browser seem to look better than icons 
 *					resized by hand. It also provides more flexibility for icon sizing
 *
 * 0.0.91		Fixed the link to Meetup
 *				Added Facebook Page link
 *
 * 0.0.9		Added Xing & Linked In Group
 *				Fixed compatibility with PHP4
 *
 * 0.0.8		Added Vimeo & External Link option
 *				Updated Tumblr image
 *				Updated Module Config Screen
 *
 * 0.0.7		Added a stack of new services: Bebo, Blinklist, Blogmarks, Brightkite, Digg,
 *					Diigo, FeedBurner, Hi5, Hyves, Meetup, Metacafe, MisterWong, Netvibes, 
 *					Newsvine, Ning, Orkut, Qik, Reader, Reddit, Simpy, StumbleUpon &
 *					Technorati. 
 *				Added Facebook Group Option
 *				Added LastFM Artist Option
 *				Changed Facebook to use new Username
 *				Pownce replaced with Vox 
 *				Updated images.
 *				MUCH improved coding!
 *
 * 0.0.6		Added Friendster, Photobucket, LinkedIn & Xbox Live.
 *
 * 0.0.5		Added Caching of the module.
 *
 * 0.0.4		Added del.icio.us, Kwippy & Last.fm.  
 *				Changed the image folder structure around.
 *				Fixed the Facebook URL.
 *
 * 0.0.3		Added Facebook
 *
 * 0.0.2		Added Flickr, Picasa, YouTube
 *
 * 0.0.1		Initial Release
 *
 **********************************************************************************/

//no direct access
defined('_JEXEC') or die('Direct Access to this location is not allowed.');

// include the helper file
require_once(dirname(__FILE__).DS.'helper.php');

// get parameters from the module's configuration
$iconsize	= $params->get('iconsize', '32');
$style		= $params->get('style', '0');
$position	= $params->get('position', 'left');
$usedb		= $params->get('usedb', '0');
$group		= $params->get('stalkergroup', '');

// Load the CSS file
JHTML::stylesheet('stalker.css', 'modules/mod_stalker/assets/css/', '');

// get the array of social networks from the helper
if ($usedb) {
	$img_path 	= StalkerHelper::getImagePathDB($iconsize);
	$socnets 	= StalkerHelper::getSocialNetworksDB($group);
} else {
	$img_path 	= StalkerHelper::getImagePath($iconsize);
	$socnets 	= StalkerHelper::getSocialNetworks();

	// get the various parameters from the Stalker Config
	foreach ($socnets as $socnet) {
		list($net, $txt, $url, $img) = $socnet;

		$net_name 		= $net . "name";

//		$$net	 		= $params->get($net, '0');
		$$net_name		= $params->get($net_name, '');
	}
}

require(JModuleHelper::getLayoutPath('mod_stalker'));

?>